<?php

if (!defined('_CAN_LOAD_FILES_'))
{
	exit;
}

class Bpay extends PaymentModule
{
	public function __construct()
	{
		$this->name = 'bpay';
		$this->tab = 'payments_gateways';
		$this->version = '1.0';
		$this->author = 'Egor';

		$this->currencies = false;

		parent::__construct();

		$this->displayName = $this->l('bpay');
		$this->description = $this->l('Payment by bpay');
	}

	public function install()
	{
		if (!parent::install()
			OR !$this->registerHook('payment')
			OR !$this->registerHook('paymentReturn')
			OR !$this->registerHook('updateOrderStatus'))
		{
			return false;
		}

		return true;
	}

	private function _displayForm()
	{
		$m_url = (Configuration::get('merchant_url') == '' ? '//bpay.md/merchant/cash.php' : Configuration::get('merchant_url'));

		$this->_html .= '
		<form method="post" action="' . $_SERVER['REQUEST_URI'] . '">
			<fieldset >
				<legend><img src="' . __PS_BASE_URI__ . 'modules/bpay/logo.png" alt="" />' . $this->l('Tools') . '</legend>
			    <div style="clear: both;"></div>
				<div style="clear: both;"></div>
				<label>' . $this->l('MerchantID') . '</label>
				<div class="margin-form">
					<input type="text" name="merchant_id" value="' . Configuration::get('merchant_id') . '" style="width: 300px;"  />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('Signature') . '</label>
				<div class="margin-form">
					<input type="text" name="secret_key" value="' . Configuration::get('secret_key') . '" style="width: 300px;" />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('method') . '</label>
				<div class="margin-form">
					<input type="text" name="method_p" value="' . Configuration::get('method_p') . '" style="width: 300px;" />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('You site url. For example: http://myshop.com') . '</label>
				<div class="margin-form">
					<input type="text" name="success_url" value="' . Configuration::get('site_url') . '" style="width: 300px;" />
				</div><br><br>
				<div style="clear: both;"></div>
				<label>' . $this->l('lang (ru, ro, en)') . '</label>
				<div class="margin-form">
					<input type="text" name="lang_p" value="' . Configuration::get('lang_p') . '" style="width: 300px;" />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('advanced1') . '</label>
				<div class="margin-form">
					<input type="text" name="advanced1" value="' . Configuration::get('advanced1') . '" style="width: 300px;" />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('advanced2') . '</label>
				<div class="margin-form">
					<input type="text" name="advanced2" value="' . Configuration::get('advanced2') . '" style="width: 300px;" />
				</div>
				<div style="clear: both;"></div>
				<label>' . $this->l('istest') . '</label>
				<div class="margin-form">
					<input type="text" name="istest" value="' . Configuration::get('istest') . '" style="width: 300px;" />
				</div>
				
				
				
				
				
				
				
				
				
				<center><input type="submit" class="button" name="btnSubmit" value="' . $this->l('Обновить') .'" style="margin-top: 25px;" /></center>
			</fieldset>
		</form>';
	}





	private function _postProcess()
	{


		if (isset($_POST['btnSubmit']))
		{



			if ($merchant_id = Tools::GetValue('merchant_id'))
			{
				Configuration::updateValue('merchant_id', $merchant_id);
			}

			if ($secret_key = Tools::GetValue('secret_key'))
			{
				Configuration::updateValue('secret_key', $secret_key);
			}
			if ($method_p = Tools::GetValue('method_p'))
			{
				Configuration::updateValue('method_p', $method_p);
			}
			if ($site_url = Tools::GetValue('site_url'))
			{
				Configuration::updateValue('site_url', $site_url);
			}
			if ($lang_p = Tools::GetValue('lang_p'))
			{
				Configuration::updateValue('lang_p', $lang_p);
			}
			if ($advanced1 = Tools::GetValue('advanced1'))
			{
				Configuration::updateValue('advanced1', $advanced1);
			}
			if ($advanced2 = Tools::GetValue('advanced2'))
			{
				Configuration::updateValue('advanced2', $advanced2);
			}
			if ($istest = Tools::GetValue('istest'))
			{
				Configuration::updateValue('istest', $istest);
			}


			$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Настройки обновлены').'</div>';
		}
	}

	public function getContent()
	{
		$this->_html = '<h2>' . $this->displayName . '</h2>';

		if (!empty($_POST))
		{
			$this->_postProcess();
		}
		else
			$this->_html .= '<br />';

		$this->_displayForm();

		return $this->_html;
	}

	public function checkCurrency($cart)
	{
		$currency_order = new Currency($cart->id_currency);
		$currencies_module = $this->getCurrency($cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}

	public function hookPayment($params)
	{
		if (!$this->active)
		{
			return ;
		}

		global $smarty;
		$order_id      = $params['cart']->id;

		$smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_bw' => $this->_path,
			'this_path_ssl' => Tools::getHttpHost(true, true) . __PS_BASE_URI__ . 'modules/' . $this->name . '/'
		));

		return $this->display(__FILE__, 'payment.tpl');



	}

	public function hookUpdateOrderStatus($params)
	{
		return true;
	}


}

